<%
Const Type_Ad=3
Const Type_SubSection=2
Const Type_Section=1

Function MaxAd(Insert, InsertType, lCurrentIndex, lCharacterCount)

	Dim lIndex
	Dim lMaxIndex
	Dim lMaxCount
	Dim lCharacters

	lMaxIndex=lCurrentIndex
	lMaxCount=Len(Insert(lCurrentIndex))
	lIndex=lCurrentIndex

	' Can't go past the Ads
	Do While(InsertType(lIndex)=Type_Ad)

		lCharacters=Len(Insert(lIndex))
		If (lCharacters<lCharacterCount) AND (lCharacters>lMaxCount) Then
			lMaxIndex=lIndex
			lMaxCount=lCharacters
		End If

		lIndex=lIndex+1

	Loop

	MaxAd=lMaxIndex

End Function

Function MinAd(Insert, InsertType, lCurrentIndex, lCharacterCount)

	Dim lIndex
	Dim lMinIndex
	Dim lMinCount
	Dim lCharacters

	lMinIndex=lCurrentIndex
	lMinCount=Len(Insert(lCurrentIndex))
	lIndex=lCurrentIndex

	' Can't go past the Ads
	Do While(InsertType(lIndex+1)=Type_Ad)

		lCharacters=Len(Insert(lIndex))

		If (lCharacters<lMinCount) Then
			lMinIndex=lIndex
			lMinCount=lCharacters
		End If

		lIndex=lIndex+1

	Loop

	MinAd=lMinIndex

End Function

Sub SwapAds(Insert, InsertType, lIndex1, lIndex2)
	
	strTemp=Insert(lIndex1)
	Insert(lIndex1)=Insert(lIndex2)
	Insert(lIndex2)=strTemp

	lTemp=InsertType(lIndex1)
	InsertType(lIndex1)=InsertType(lIndex2)
	InsertType(lIndex2)=lTemp
		
End Sub

' Rearrange juggles the advertisments trying to get  
' the best one for the spot available
' If True is returned it is time for a new column

Function Rearrange(Insert, InsertType, lCurrentIndex, lCharacterCount)

	Rearrange=False

	If (InsertType(lCurrentIndex)=Type_Ad) Then

		lBiggestAdIndex=MaxAd(Insert, InsertType, lCurrentIndex, lCharacterCount)
		lBiggestAdCharacterCount=Len(Insert(lBiggestAdIndex))
	
		If (lBiggestAdCharacterCount<lCharacterCount) Then 
			If (lCurrentIndex<>lBiggestAdIndex) Then
				SwapAds Insert, InsertType, lCurrentIndex, lBiggestAdIndex
			End If
			Exit Function
		End If

		lCurrentAdCharacterCount=Len(Insert(lCurrentIndex))

		If (lCurrentAdCharacterCount<lCharacterCount) Then
			Exit Function
		End If

		lSmallestAdIndex=MinAd(Insert, InsertType, lCurrentIndex, lCharacterCount)
		lSmallestAdCharacterCount=Len(Insert(lSmallestAdIndex))

		If (lSmallestAdCharacterCount<lCharacterCount) Then
			SwapAds Insert, InsertType, lCurrentIndex, lSmallestAdIndex
		Else
			SwapAds Insert, InsertType, lCurrentIndex, lSmallestAdIndex
			Rearrange=True
		End If

	End If

End Function

Sub ColumnsByKeyWord(strKeyword)

	strSQLWhere = "(Post_Text LIKE '%" & strKeyword & "%' OR Post_Title LIKE '%" & strKeyword & "%') AND Post_Region_Id IN (" & UserPreferredRegions & ")"
	Call Columns(strSQLWhere)

End Sub

Function UserPreferredRegions()
	
	Dim		strAll

	Set oRS = oConn.Execute("SELECT DISTINCT Region_Id 'Id', Region_Title 'Title' FROM Region ORDER BY Region_Title")

	Do While (Not oRS.EOF)

		' Construct Index
		strIndex = "Region:" & oRS("Id")

		If (oXSession(strIndex)="On") Then

			If (Len(UserPreferredRegions)>0) Then
				UserPreferredRegions=UserPreferredRegions & ","
			End If

			UserPreferredRegions=UserPreferredRegions & oRS("Id")
		End If

		If (Len(strAll)>0) Then
			strAll=strAll & ","
		End If

		strAll=strAll  & oRS("Id")

		oRS.MoveNext				

	Loop

	If (Len(UserPreferredRegions)=0) Then
		UserPreferredRegions=strAll	
	End If

	oRS.Close

End Function

Sub ColumnsBySubSection (lSubSection)

	strSQLWhere = "SubSection_Id=" & lSubSection & " AND Post_Region_Id IN (" & UserPreferredRegions & ")"
	Call Columns(strSQLWhere)

End Sub

Sub NewColumns ()

	' If there hasn't been a posting for a while
	' then we do not want the page to be blank.
	' So we count the number of postings, and if
	' it is zero then we increase the new days
	' until we have some results 

	' Note this routine causes extra stress on 
	' the SQL Server, however, not having a blank 
	' page is worth it.  To reduce the workload
	' increase the value of glNewDays in the global.asp
	
	' Notice that this will not work if the
	' global new days setting is zero
	If (glNewDays=0) Then
		lIncrement=1
	Else
		lIncrement=glNewDays
	End If

	lNewDays=lIncrement

	' Intialize lPostCount so that we can enter
	' the loop
	lPostCount=0

	' Initalize the User's Regional Preferences
	strUserPerference = UserPreferredRegions
	Response.Write("<!-- Regional Perference " & strUserPerference & "-->")

	' Get the Number of Post Possible
	strSQL = "SELECT COUNT(Post_Id) 'Count' FROM Post WHERE Post_Region_Id IN (" & strUserPerference & ")"
	Set oRS=oConn.Execute(strSQL)
	If (Not oRS.EOF) Then
		' There is a count so retrieve it
		lPostCap=oRS("Count")
	End If
	oRS.Close

	' Adjust the Post Cap
	If (lPostCap>glNewAdMin) Then
		lPostCap=glNewAdMin
	End If

	Do While (lPostCount<lPostCap)

		' The count of the postings within lNewDays days.
		strSQL = "SELECT COUNT(Post_Id) 'Count' FROM Post WHERE Post_Region_Id IN (" & strUserPerference & ") AND (DATEDIFF(day,Post_Date,GetDate())<" & lNewDays & ")"
		Set oRS=oConn.Execute(strSQL)

		If (Not oRS.EOF) Then
			' There is a count so retrieve it
			lPostCount=oRS("Count")
		End If

		' There aren't enough Postings so increase the period.
		If (lPostCount<lPostCap) Then
			lNewDays = lNewDays + lIncrement
		End If

		oRS.Close
	Loop
	
	' Now that we know the correct setting display the page
	strSQLWhere = "Post_Region_Id IN (" & strUserPerference & ") AND (DATEDIFF(day,Post_Date,GetDate())<" & lNewDays & ")"
	Call Columns(strSQLWhere)

End Sub

Sub Columns (strSQLWhere)

		' Initalize Insert

		lCharacterCount=0
		lIndex=0
		lInsertSize=glInsertSizeIncrement
		lCurrentSection=0
		lCurrentSubSection=0

		Dim	Insert
		Dim InsertType

		Redim	Insert(lInsertSize)
		Redim	InsertType(lInsertSize)

		' Build SQL String

		strSQL ="SELECT Post_Id 'Id', Post_Title 'Title', Section_Id 'Section', SubSection_Id 'SubSection',  Post_Date 'Date', Post_Text 'Text' " &_
			"FROM Post, SubSection, Section " &_
			"WHERE SubSection_Section_Id = Section_Id AND Post_SubSection_Id=SubSection_Id AND " & strSQLWhere & " " &_
			"ORDER BY Section_Title, SubSection_Title"

		' Build Insert

		Set oConn2 = Server.CreateObject("ADODB.Connection")
		oConn2.Open SQLDSN,SQLUser,SQLPassword

		Set oRS = oConn.Execute(strSQL)
		
		Do While (Not oRS.EOF)

			lId = oRS("Id")
			strTitle = oRS("Title")
			strText = oRS("Text")
			dtDate = oRS("Date")
			lSubSection = oRS("SubSection")
			lSection = oRS("Section")
				
			' Increment Index
			lIndex=lIndex+1

			' Make Sure Insert is not too small
			Do While(lIndex>=lInsertSize)
				lInsertSize=lInsertSize+glInsertSizeIncrement
				Redim Preserve Insert(lInsertSize)
				Redim Preserve InsertType(lInsertSize)
			Loop

			' If the Section has changed we need
			' to insert a Section delimiter before
			' the advertisment

			If (lCurrentSection<>lSection) Then
				Set oRS2 = oConn.Execute("SELECT Section_Title 'Title', Section_SubTitle 'SubTitle' FROM Section WHERE Section_Id=" & lSection)
				If (Not oRS2.EOF) Then
					strSectionTitle = oRS2("Title")
					strSectionSubTitle = oRS2("SubTitle")
				End If
				
				Insert(lIndex) ="<TR><TD VALIGN=TOP BGCOLOR=""" & gstrPColor &"""><TABLE WIDTH=100% CELLPADDING=0 CELLSPACING=0 BORDER=0><TR><TD BGCOLOR=""" & gstrTextColor & """ HEIGHT=5></TD></TR><TR><TD><FONT SIZE=+5>" & strSectionTitle & "</FONT></TD></TR><TR><TD><B>" & strSectionSubTitle & "</B></TD></TR></TABLE></TD></TR>"

				InsertType(lIndex)=Type_Section

				' Count the Words
				CharacterCount=CharacterCount+Len(Insert(lIndex))			

				' Increment Index
				lIndex=lIndex+1

				' Make Sure Insert is not too small
				Do While(lIndex>=lInsertSize)
					lInsertSize=lInsertSize+glInsertSizeIncrement
					Redim Preserve Insert(lInsertSize)
					Redim Preserve InsertType(lInsertSize)
				Loop

				lCurrentSection=lSection

				oRS2.Close
			End If

			' If the SubSection has changed we need
			' to insert a subsection delimiter before
			' the advertisiment

			If (lCurrentSubSection<>lSubSection) Then
				Set oRS2 = oConn.Execute("SELECT SubSection_Title 'Title', SubSection_SubTitle 'SubTitle' FROM SubSection WHERE SubSection_Id=" & lSubSection)
				If (Not oRS2.EOF) Then
					strSubSectionTitle = oRS2("Title")
					strSubSectionSubTitle = oRS2("SubTitle")
				End If
				
				Insert(lIndex) ="<TR><TD ALIGN=CENTER BGCOLOR=""" & gstrSColor & """ VALIGN=TOP><B> " & strSubSectionTitle & " " & strSubSectionSubTitle & "</B><BR><TABLE WIDTH=50><TR><TD HEIGHT=3 BGCOLOR=""" & gstrTextColor & """></TD></TR></TABLE></TD></TR>"

				InsertType(lIndex)=Type_SubSection

				' Count the Words
				CharacterCount=CharacterCount+Len(Insert(lIndex))			

				' Increment Index
				lIndex=lIndex+1

				' Make Sure Insert is not too small
				Do While(lIndex>=lInsertSize)
					lInsertSize=lInsertSize+glInsertSizeIncrement
					Redim Preserve Insert(lInsertSize)
					Redim Preserve InsertType(lInsertSize)
				Loop

				lCurrentSubSection=lSubSection

				oRS2.Close
			End If

			
			' Put together advertisment

			dtNowDate=Now()
			Days=DateDiff ("d",dtDate,dtNowDate)
			
			If (Days<glNewDays) Then
				Insert(lIndex) = "<TR><TD ALIGN=TOP><B><A  CLASS=""clsLink"" HREF=""javascript:showAdWindow(" & lId & ")""><IMG BORDER=0 SRC=""new.gif""> " & strTitle & "</B> " & strText & "</A></TD></TR>"
			Else
				Insert(lIndex) = "<TR><TD ALIGN=TOP><B><A TITLE=""" & gstrClickOn & """ CLASS=""clsLink"" HREF=""javascript:showAdWindow(" & lId & ")"">" & strTitle & "</B> " & strText & "</A></TD></TR>"
			End If

			InsertType(lIndex)=Type_Ad

			' Count the Words
			CharacterCount=CharacterCount+Len(Insert(lIndex))			

			oRS.MoveNext
		Loop

		oRS.Close
		oConn2.Close

		' Output Columns		

		If (CharacterCount>0) Then

			' Intialize 
			lColumnIndex=1
			lCurrentAdsInColumn=0
			lMaxIndex=lIndex
			lIndex=0
			lCurrentColumnCharacterCount=0
			lIdealCharactersPerColumn=(CharacterCount/glTrueColumns)
			
			Response.Write("<TD VALIGN=TOP WIDTH=" & glColumnWidth & "><TABLE VALIGN=TOP WIDTH=100% CELLSPACING=2 CELLPADDING=0 BORDER=0>")

			Do While (lIndex<lMaxIndex)

				' Increment Index
				lIndex=lIndex+1

				bNewColumn=Rearrange(Insert, InsertType, lIndex, lIdealCharactersPerColumn-lCurrentColumnCharacterCount)

				' Write the Text
				Response.Write(Insert(lIndex))

				' Write a Divider
				Response.Write("<TR><TD><TABLE WIDTH=100% CELLSPACING=0 CELLPADDING=0 BORDER=0 BGCOLOR=""" & gstrTextColor & """><TR><TD HEIGHT=1></TD></TR></TABLE></TD></TR>")

				If ((bNewColumn=True) AND (lColumnIndex < glTrueColumns) AND (lCurrentAdsInColumn>0)) Then

					' Write the Text to Create another Column
					Response.Write("</TABLE></TD><TD WIDTH=1 BGCOLOR=""" & gstrTextColor & """></TD><TD VALIGN=TOP WIDTH=" & glColumnWidth & "><TABLE WIDTH=100% CELLSPACING=2 CELLPADDING=0 BORDER=0>")

					' Intialize the Column Variables
					lCurrentColumnCharacterCount=0
					lCurrentAdsInColumn=0

					' Write the last SubSection header stored
					' if there is another advertisment coming
					If (InsertType(lIndex+1)=Type_Ad) Then
						Response.Write(strHeader)

						' Write a Divider
						Response.Write("<TR><TD><TABLE WIDTH=100% CELLSPACING=0 CELLPADDING=0 BORDER=0 BGCOLOR=""" & gstrTextColor & """><TR><TD HEIGHT=1></TD></TR></TABLE></TD></TR>")
						lCurrentColumnCharacterCount=lCurrentColumnCharacterCount+Len(strHeader)
					End If

					' Increment the Column Index
					lColumnIndex=lColumnIndex+1

				End If			
			
				' If the Text is a SubSection Header
				' then Store the Header in case
				' we need to create another column
				If (InsertType(lIndex)=Type_SubSection) Then
					strHeader=Insert(lIndex)
				End If

				' If the Insert Type is an Ad then
				' increment To enforce the One Ad per
				' Column Rule
				If (InsertType(lIndex)=Type_Ad) Then
					lCurrentAdsInColumn=lCurrentAdsInColumn+1
				End If

				' Increment the Current Word Count
				lCurrentColumnCharacterCount=lCurrentColumnCharacterCount+Len(Insert(lIndex))

			Loop

			' Back Fill with Blank Columns
			Do While (lColumnIndex<glTrueColumns)
				' Write the Text to Create another Column
				Response.Write("</TABLE></TD><TD WIDTH=1 BGCOLOR=""" & gstrTextColor & """></TD><TD VALIGN=TOP WIDTH=" & glColumnWidth & "><TABLE WIDTH=100% CELLSPACING=2 CELLPADDING=0 BORDER=0>")
				lColumnIndex=lColumnIndex+1
			Loop

			Response.Write("</TABLE></TD>")
		Else
			Response.Write("<TR>")
			Response.Write("<TD VALIGN=MIDDLE HEIGHT=100 ALIGN=CENTER WIDTH=100% >")
			Response.Write("<FONT SIZE=+1>" & gstrEmtpy & "</FONT>")
			Response.Write("</TD>")
			Response.Write("</TR>")
		End If

End Sub
%>